FULL_PACKAGE_VERSION = "2.19"

IS_UPDATE_VERSION_CACHE = false
local writePath = cc.FileUtils:getInstance():getWritablePath()
local function removeDirectory( dir )
    local fileUtil = cc.FileUtils:getInstance()
    local dirPath = writePath .. dir
    if fileUtil:isDirectoryExist(dirPath) then
        if cc.Application:getInstance():getTargetPlatform() == 0 then
            local command = "cmd /c rd /s /q "
            command = command .. "\"" .. dirPath .. "\""
            os.execute(command)
        else
            fileUtil:removeDirectory(dirPath)
        end
    end
end

local function SplitFunction(szFullString, szSeparator)
    local nFindStartIndex = 1
    local nSplitIndex = 1
    local nSplitArray = {}
    while true do
       local nFindLastIndex = string.find(szFullString, szSeparator, nFindStartIndex, true)
       if not nFindLastIndex then
        nSplitArray[nSplitIndex] = string.sub(szFullString, nFindStartIndex, string.len(szFullString))
        break
       end
       nSplitArray[nSplitIndex] = string.sub(szFullString, nFindStartIndex, nFindLastIndex - 1)

       nFindStartIndex = nFindLastIndex + string.len(szSeparator)
       nSplitIndex = nSplitIndex + 1
    end
    return nSplitArray
end

local function updateVersionCache()
    local crtVersion = cc.UserDefault:getInstance():getStringForKey("native_version")

    print("cacheVersion-----------------------------------------" .. tostring(crtVersion))
    print("natvieVersion-----------------------------------------" .. FULL_PACKAGE_VERSION)
    if  (not crtVersion) or (crtVersion == "") then
        IS_UPDATE_VERSION_CACHE = true
    else
        local versionTb = SplitFunction(crtVersion, '.')       
        local nativeFullTb = SplitFunction(FULL_PACKAGE_VERSION, '.')

        if #versionTb > 0 and #nativeFullTb > 0 then
            if versionTb[1] and versionTb[2] then
                local versionName = tostring(versionTb[1]) .. "." .. tostring(versionTb[2])
                local serverVersionName = tostring(nativeFullTb[1]) .. "." .. tostring(nativeFullTb[2])

                print("versioName---------------------------------" .. versionName)
                print("serverVersionName-----------------------------" .. serverVersionName)

                if (tonumber(versionTb[1]) < tonumber(nativeFullTb[1])) or 
                        (tonumber(versionTb[1]) == tonumber(nativeFullTb[1]) and tonumber(versionTb[2]) < tonumber(nativeFullTb[2])) then
                    IS_UPDATE_VERSION_CACHE = true
                end
            end
        end
    end
    if not IS_UPDATE_VERSION_CACHE and cc.Application:getInstance():getTargetPlatform() == 0 then
        --PC端还有一种情况：包体版本号大于本地记录的更新版本号
        local nativeluaPath=cc.FileUtils:getInstance():fullPathForFilename("src/nativeVersion.lua")
        print("nativeluaPath------------------",nativeluaPath)
        local file = io.open(nativeluaPath,"r")
        if file then
            local ver_sub = file:read() -- APP_VERSION_CODE = 25
            ver_sub = string.sub(ver_sub, string.find(ver_sub, "= ") + 2, -1)
            local ver_full = file:read() -- APP_VERSION_NAME = "2.3"
            ver_full = string.sub(ver_full, string.find(ver_full, "= ") + 3, -2)
            file:close()
            local packageVersiton = ver_full .. "." .. ver_sub -- 安装包版本号: 2.x.xx

            local updateVer_tbStr = SplitFunction(crtVersion, ".") -- {2, x, xx}
            local packageVer_tbStr = SplitFunction(packageVersiton, ".") -- {2, x, xx}
            local updateVer_tb = {}
            local packageVer_tb = {}
            for i,str in ipairs(updateVer_tbStr) do
                updateVer_tb[i]=tonumber(str)
            end
            for i,str in ipairs(packageVer_tbStr) do
                packageVer_tb[i]=tonumber(str)
            end

            if updateVer_tb[1] < packageVer_tb[1] or
                (updateVer_tb[1] == packageVer_tb[1] and updateVer_tb[2] < packageVer_tb[2] ) or
                (updateVer_tb[1] == packageVer_tb[1] and updateVer_tb[2] == packageVer_tb[2] and updateVer_tb[3] < packageVer_tb[3] ) then
                    IS_UPDATE_VERSION_CACHE = true
            end
        end
    end
    if IS_UPDATE_VERSION_CACHE then
        removeDirectory("src/")
        removeDirectory("res/")
    end
end


updateVersionCache()